//
//
//   evalop.h - evaluation operator
//
//   Copyright (C) 2015 by Matt Roberts.
//   License: GNU GPL3 (www.gnu.org)
//
//
//   Modified from OpenBeagle example:
//      Open BEAGLE
//      Copyright (C) 2001-2007 by Christian Gagne and Marc Parizeau
//
//

#ifndef __LOOP_EVAL_OP_H
#define __LOOP_EVAL_OP_H

#include "config.h"

namespace Basic {
	//
	//  the basic evaluation operator
	//
	class LoopEvalOp : public Beagle::EvaluationOp {
		public:

			//! LoopEvalOp allocator type.
			typedef Beagle::AllocatorT<LoopEvalOp,Beagle::EvaluationOp::Alloc>
				Alloc;
			//!< LoopEvalOp handle type.
			typedef Beagle::PointerT<LoopEvalOp,Beagle::EvaluationOp::Handle>
				Handle;
			//!< LoopEvalOp bag type.
			typedef Beagle::ContainerT<LoopEvalOp,Beagle::EvaluationOp::Bag>
				Bag;

			explicit LoopEvalOp();

			virtual Beagle::Fitness::Handle evaluate(Beagle::Individual& inIndividual,
					Beagle::Context& ioContext);
			virtual void initialize(Beagle::System& ioSystem);
			virtual void postInit(Beagle::System& ioSystem);

		protected:
			// the 'frequency' as a float
			Beagle::Vector::Handle m_Freq;
			// the 'power' as a float
			Beagle::Float::Handle m_Power;
	};
}

#endif // __LOOP_EVAL_OP_H
