//
//
//   fitness.cc - fitness evaluation type
//
//   Copyright (C) 2015 by Matt Roberts.
//   License: GNU GPL3 (www.gnu.org)
//
//

#include <cmath>

#include "fitness.h"
#include "config.h"

namespace LoopFormulae {
	Fitness::Fitness(const FitnessProduct &product) {
		m_Product = product;
	}

	Fitness::~Fitness() {
		// nop
	}

	double Fitness::Value(const LoopConfig &c) const {
		double n = 1.0;
		for (FitnessProduct::const_iterator i = m_Product.begin(); i != m_Product.end(); ++i) {
			double base = i->Func ? i->Func(c) : 1.0;
			n *= (i->Coef * pow(base, i->Exp));
		}
		return n;
	}
}
